(function() {
	tpl.at = {};
	
	//
	// Add the titles of the test cases to the list to get them loaded to the table view
	//
	tpl.at.createData = function () {
		var acceptanceData = [
		// {title:'TIMOBXXXX', hasChild:true, level:"acceptance"},
		{title:'TIMOB4696', hasChild:true, level:"acceptance"},
		{title:'TIMOB5278', hasChild:true, level:"acceptance"},
		{title:'TIMOB5494_A', hasChild:true, level:"acceptance"},
		{title:'TIMOB5494_B', hasChild:true, level:"acceptance"}
		]
		
		return acceptanceData;
	};
	
	//
	// TIMOB-XXXX
	// JIRA Issue title
	//
	tpl.at.TIMOBXXXX = function(_window) {
	 
	    if(!(Ti.Platform.osname == 'ipad' || Ti.Platform.osname == 'iphone')) { // effectively a list of supported platforms
	        var label = tpl.ui.getSkipLabel();
	        _window.add(label);
	        return _window;
	    }
	};
	
	//
	// TIMOB-4696
	// iOS: Cannot retrieve property value set in tiapp.xml using Ti.App.Properties API
	//
	tpl.at.TIMOB4696 = function(_window) {
		
		var property = Ti.App.Properties.getString('XMLProperty');
		
		if(property != null)
			alert(property + ' present.');
		else
			alert('Error: Cannot access XML Property.');
		
		return _window;
	};
	
	//
	// TIMOB 5278
	// iOS: App properties don't immediately register a changed value
	//
	tpl.at.TIMOB5278 = function(_window) {
		
		// Titanium.App -> 'resumed' event is iOS-specific
	    if(!(Ti.Platform.osname == 'ipad' || Ti.Platform.osname == 'iphone')) { // effectively a list of supported platforms
	        var label = tpl.ui.getSkipLabel();
	        _window.add(label);
	        return _window;
	    }

		var win = _window;
		
		var label = Ti.UI.createLabel({
			text:'1. \'Back\' the app. \n\n2. Change Settings -> AppPropertiesModule -> Test Property \n\n3. Re-open app. \n\nValues should be identical: (0=0, or 1=1).',
			top:'20%',
			bottom:'20%',
			left:'20%',
			right:'20%'
		});
		
		win.add(label);
		
		Ti.App.addEventListener('resumed', function() {
			var output = "T0 Value: " + Titanium.App.Properties.getString('testproperty') + '\n\n';
			
			setTimeout(function() {
				output += "T1 Value: " + Titanium.App.Properties.getString('testproperty') + '\n\n';
				alert(output);
			}, 2000);
		});
		
		return _window;
	};
	
	//
	// TIMOB-5494 Part A
	// iOS: userDefaults not remembering the properties that were set
	//
	tpl.at.TIMOB5494_A = function (_window) {
		tpl.at.TIMOB5494State = 1;
		
		var property = 'myProperty';
		var value = 'dadfcool';
		
		// Create Property
		Titanium.App.Properties.setString(property, value);
		
		var hasProperty = Ti.App.Properties.hasProperty(property);
		try {
			if(hasProperty)
			{
				alert('Property: ' + property + '(' + value + ')' + ' Created.');
			}
			else
			{
				throw 'Property: ' + property + '(' + value + ')' + ' Failed to Create.';
			}
		}
		catch(err){
			alert(err);
		}

		var label = Ti.UI.createLabel({
			text:'Hard re-start app and check TIMOB5494_B for property persistence.',
			top:'20%',
			bottom:'20%',
			left:'20%',
			right:'20%'
		});
		
		_window.add(label);
			
		return _window;
	};
	
	//
	// TIMOB-5494 Part B
	// iOS: userDefaults not remembering the properties that were set
	//
	tpl.at.TIMOB5494_B = function (_window) {
		try {
			if(tpl.at.TIMOB5494State == 1)
			{
				throw 'Hard Re-Start App to Test TIMOB5494_B.';
			}
				
			var property = 'myProperty';
	
			var hasProperty = Ti.App.Properties.hasProperty(property);
			
			if(hasProperty)
			{
				var value = Ti.App.Properties.getString(property);
				
				alert('Property: ' + property + '(' + value + ')' + ' Persistent.');
			}
			else
			{
				throw 'Property: ' + property + ' Failed to Persist.';
			}
		}
		catch(err) {
			alert(err);
		}

		var label = Ti.UI.createLabel({
			text:'End TIMOB5494 Test.',
			top:'20%',
			bottom:'20%',
			left:'20%',
			right:'20%'
		});
		
		_window.add(label);
			
		return _window;
	};
})();